//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "FarHeaders\plugin.hpp"
#pragma hdrstop

#include "utils.h"
#include "TextMessages.h"
#include "MsgBox.h"
#include "Registry.h"

#include "ModuleWork.h"
//---------------------------------------------------------------------------
extern struct PluginStartupInfo Info;

int ModuleType = 0; // 0 - C
                    // 1 - CPP

//      CBuilder'. 
const char comment[] = "//---------------------------------------------------------------------------";

//---------------------------------------------------------------------------
void RunModuleCreation(void)
{
  ModuleType = GetRegKey(HKEY_CURRENT_USER,"","ModuleType", 0);

  const DialogWidth = 50;
  const DialogHeight = 6;

  const DialogItemsCount = 5;

  const char *ModuleNameHistoryName = "kvmodule_LastModuleName";

  struct InitDialogItem InitItems[DialogItemsCount] = {
    DI_DOUBLEBOX,0,0,DialogWidth,DialogHeight,0,0,0,0,(char *)MCreationDlgTitle,

    DI_EDIT,2,1,48,0,1,(DWORD)ModuleNameHistoryName,DIF_HISTORY | DIF_USELASTHISTORY,0,"",

    DI_SINGLEBOX,2,3,35,5,0,0,0,0,(char *)MModuleType,
    DI_RADIOBUTTON,4,4,0,0,0,ModuleType == 0,DIF_GROUP,0,(char *)MC,
    DI_RADIOBUTTON,14,4,0,0,0,ModuleType == 1,0,0,(char *)MCPP,
  };

  struct FarDialogItem DialogItems[DialogItemsCount];

  InitDialogItems(InitItems, DialogItems, DialogItemsCount);

  //  
  int res = Info.Dialog(Info.ModuleNumber, -1, -1, DialogWidth, DialogHeight,
                        "Contents", DialogItems, DialogItemsCount);

  //  "Esc"
  if ( res == -1 ) return;

  ModuleType = DialogItems[3].Selected ? 0 : 1;

  SetRegKey(HKEY_CURRENT_USER,"","ModuleType", ModuleType);

  char *ModuleName = DialogItems[1].Data;

  char FileName[1024];

  //
  //   .C  .CPP
  //

  strcpy(FileName, ModuleName);
  strcat(FileName, ModuleType == 0 ? ".c" : ".cpp");

  FILE *f = fopen(FileName, "wt");

  if ( f == NULL ) {
    ErrorMessage(MError, MCannotCreateFile);
    return;
  }

  fprintf(f, "%s\n", comment);
  fprintf(f, "#include \"%s.h\"\n\n", ModuleName);
  fprintf(f, "%s\n", comment);
  fclose(f);

  //
  //   .H
  //

  strcpy(FileName, ModuleName);
  strcat(FileName, ".h");

//  ,         ".h".
//         ".hpp",    :  
//  strcat(FileName, ModuleType == 0 ? ".h" : ".hpp");

  f = fopen(FileName, "wt");

  if ( f == NULL ) {
    ErrorMessage(MError, MCannotCreateFile);
    return;
  }

  fprintf(f, "%s\n", comment);
  fprintf(f, "#ifndef %sH\n", ModuleName);
  fprintf(f, "#define %sH\n", ModuleName);
  fprintf(f, "%s\n", comment);
  fprintf(f, "%s\n", comment);
  fprintf(f, "#endif\n", ModuleName);
  fclose(f);
}

