//---------------------------------------------------------------------------
#include <windows.h>
#include <string.h>
#include "FarHeaders\plugin.hpp"

#pragma hdrstop

#include "utils.h"
#include "TextMessages.h"

//---------------------------------------------------------------------------
extern struct PluginStartupInfo Info;

//---------------------------------------------------------------------------
void ShowErrorMessage(char *Title, char *Message)
{
  const char *Msg[7];

  Msg[0]=Title;
  Msg[1]=GetMsg(MSpace);
  Msg[2]=Message;
  Msg[3]=GetMsg(MSpace);
  Msg[4]=GetMsg(MSpace);
  Msg[5]="\x01";                   /* separator line */
  Msg[6]=GetMsg(MButton);

  Info.Message(Info.ModuleNumber,  /* PluginNumber */
               FMSG_WARNING|FMSG_LEFTALIGN,  /* Flags */
               "Contents",         /* HelpTopic */
               Msg,                /* Items */
               7,                  /* ItemsNumber */
               1);                 /* ButtonsNumber */
}
//---------------------------------------------------------------------------
void ErrorMessage(int TitleIndex, int MessageIndex)
{
  ShowErrorMessage(GetMsg(TitleIndex), GetMsg(MessageIndex));
}
//---------------------------------------------------------------------------
void ErrorMessage(int TitleIndex, char *Message)
{
  ShowErrorMessage(GetMsg(TitleIndex), Message);
}
//---------------------------------------------------------------------------
void ShowLastError(int TitleIndex)
{
  char MsgBuf[200];

  FormatMessage(
                FORMAT_MESSAGE_FROM_SYSTEM,
                NULL,
                GetLastError(),
                MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                MsgBuf,
                sizeof(MsgBuf),
                NULL
               );

  for ( int i = 0; i != sizeof(MsgBuf); i ++ )
    if ( (unsigned char)MsgBuf[i] < ' ' ) {
      MsgBuf[i] = 0;
      break;
    }

  char MsgBuf1[200];

  CharToOem(MsgBuf, MsgBuf1);

  ErrorMessage(TitleIndex, MsgBuf1);
}
